﻿from __future__ import division
from __future__ import with_statement
import es
import cPickle
import popuplib
import playerlib
import cfglib
import langlib
import threading
import esamlib
import gamethread
import os
import pymysql
import random
import effectlib          
import usermsg            
import weaponlib     
from configobj import ConfigObj


############Dicts and Lists###############
setup_dict = dict()                      #
damageTaken = dict()                     #
featuresList = list()                    #
chickenlist = list()                     #
zombielist = list()                      #
chickenlist2 = list()                    #
zombielist2 = list()                     #
restrictedList = list()                  #
saveWeapon = list()                      #
playerinfo = dict()                      #                          
##########################################


apath = es.getAddonPath('PremiumMod')
models_t = ConfigObj(apath + "/models_terrorist.ini")
models_ct = ConfigObj(apath + "/models_counterterrorist.ini")
config = cfglib.AddonCFG(apath + "/settings.cfg")
config.text("*******************************")
config.text("    PremiumMod Settings        ")
config.text("*******************************")
pm_force_pm = config.cvar("pm_force_pm",   '!premium', "Here you can set the Chatcommand which opens Premium Menu")
pm_host_set = config.cvar("pm_host_set",   'db4free.net', "Here you can set the Host of your Databases of your Homepage.(IMPORTANT: DATABASE NEEDS EXTERN ACSESS)")
pm_host_user = config.cvar("pm_host_user",   'roofm', "Here you can set the User of your Databases of your Homepage.")
pm_host_userpw = config.cvar("pm_host_userpw",   '090778156', "Here you can set the PW of your Databases of your Homepage.")
pm_host_userdb = config.cvar("pm_host_userdb",   'roofm', "Here you can set the Databasename of your Databases of your Homepage.")
URL = config.cvar("URL",'http://roofm.ro.funpic.de', "Your Link to your Premium Mod Page")
pm_message_allow = config.cvar("pm_message_allow",   1, "1 = Enable 0 = Disable (If you want to allow Premium Users to announce Message on connect")
pm_sound_allow = config.cvar("pm_sound_allow",   1, "1 = Enable 0 = Disable (If you want to allow Premium Users to announce Sound on connect")
outofdateannounce = config.cvar("outofdateannounce",   1, "1 = Enable 0 = Disable (If you want to get a Message sotred in TXT File is your Script is outdated)")
pm_sound_path = config.cvar("pm_sound_path",   'premiumMod/connect.mp3', "Here you can set the Soundpath to PremiumSound")
pm_reserve_allow = config.cvar("pm_reserve_allow",   1, "1 = Enable 0 = Disable (If Premium User want to Connect when Server is full he can join also (random Player will be kicked then))")
pm_chicken_allow = config.cvar("pm_chicken_allow",   1, "1 = Enable 0 = Disable (If Premium User want to Play as Chicken)")
pm_chicken_force = config.cvar("pm_chicken_force",   'chicken', "if pm_chicken_enabled is enabled you can set here the Chat command to play as Chicken")
pm_chicken_hp = config.cvar("pm_chicken_hp",   100, "if pm_chicken_enabled is enabled you can set here the Hp when you spawn as Chicken")
pm_chicken_regeneration = config.cvar("pm_chicken_regeneration",   1, "if pm_chicken_enabled is enabled you can set here Regenerationhp done by every Second")
pm_zombie_allow = config.cvar("pm_zombie_allow",   1, "1 = Enable 0 = Disable (If Premium User want to Play as Zombie)")
pm_zombie_force = config.cvar("pm_zombie_force",   'zombie', "if pm_zombie_enabled is enabled you can set here the Chat command to play as Zombie")
pm_zombie_hp = config.cvar("pm_zombie_hp",   200, "if pm_zombie_enabled is enabled you can set here the Hp when you spawn as Zombie")
pm_zombie_regeneration = config.cvar("pm_zombie_regeneration",   2, "if pm_zombie_enabled is enabled you can set here Regenerationhp done by every Second")
pm_awp_allow = config.cvar("pm_awp_allow",   1, "1 = Enable 0 = Disable (Here can you set if the Premium User can have weapons that normal Players do not can use)")
restricted  = config.cvar("restricted",   'awp;scout', "If pm_awp_allow is enabled you can set here the weapons that only the Premium Users can Use! (Split the Weapons with ;)")
pm_speed_allow = config.cvar("pm_speed_allow",   1, "1 = Enable 0 = Disable (Here can you set if the Premium Users Speed")
pm_speed_var = config.cvar("pm_speed_var",   1.4, "If pm_speed_allow is eneabled you can set there the Players Speed (< 0.1 - 1 is lower > 1. - 1.9 is higer")
pm_uammo_allow = config.cvar("pm_uammo_allow",   1, "1 = Enable 0 = Disable (Here you can set if You want to allow Premium Users Unlimit Ammo)")
pm_uammo_type = config.cvar("pm_uammo_type",   1, "1 = Unlimit Ammo with Reload, 2 = No Reload)")
pm_prmessage_allow = config.cvar("pm_prmessage_allow",   1, "1 = Enable 0 = Disable (Here you can set if You want to allow Users to See Eneyms Privat Chat)")
pm_killassist_allow = config.cvar("pm_killassist_allow",   1, "1 = Enable 0 = Disable (Here you can set if You want to allow Premium Users to get Points if a Hurted Enemy of them get killed")
pm_healthbonus_allow = config.cvar("pm_healthbonus_allow",   1, "1 = Enable 0 = Disable  Here you can set if You want to allow Premium Users to Give more Health on Spawn and When they Kill an Enemy")
pm_healthbonus_var = config.cvar("pm_healthbonus_var",   10, "If pm_healthnonus_allow is enabled you can set there the healthbonus")
pm_killhbonus_var = config.cvar("pm_killhbonus_var",   15, "If pm_healthnonus_allow is enabled you can set there the healthbonus")
pm_vampnade_allow = config.cvar("pm_vampnade_allow",   1, "1 = Enable 0 = Disable  Here you can set if You want to allow Premium Users to get the Damage that they have made with HE as HP")
pm_vampnade_percent = config.cvar("pm_vampnade_percent",   60, "If pm_vampnade_allow is enabledyou can Set here the Procent that you want to Give Premium Users as HP Back when they hit a Enemy with HE")
pm_respawn_allow = config.cvar("pm_respawn_allow",   1, "1 = Enable 0 = Disable  Here you can set if You want to allow Premium Users to have the Chance to Respawn")
pm_respawn_chance = config.cvar("pm_respawn_chance",   40, "If pm_respawn_allow is enabled you can set the Procent chance that the Premium Users have to respawn")
pm_nofalldmg_allow = config.cvar("pm_nofalldmg_allow",   1, "1 = Enable 0 = Disable  Here you can set if You want to allow Premium Users to make no Damage by Falling")
pm_noowndmg_allow = config.cvar("pm_noowndmg_allow",   1, "1 = Enable 0 = Disable  Here you can set if You want to allow Premium Users to make no Damage by own He's")
pm_cash_allow = config.cvar("pm_cash_allow",   1, "1 = Enable 0 = Disable  Here you can set if You want to allow Premium Users to Have more Cash")
pm_cash_var = config.cvar("pm_cash_var",   20000, "If pm_cash_allow is enabled you can set the Number of cash that you want to give Premium Users")
pm_flashbang_allow = config.cvar("pm_flashbang_allow",   1, "1 = Enable 0 = Disable  Here you can set if You want to allow Premium Users to Use More Flashbangs")
pm_flashbang_var = config.cvar("pm_flashbang_var",   3, "If pm_flashbang_allow is enabled you can set the number of Flasbangs that the Premium User will get")
pm_smokegran_allow = config.cvar("pm_smokegran_allow",   1, "Here you can set if You want to allow Premium Users to Use more Smoke Grenades")
pm_smokegran_var = config.cvar("pm_smokegran_var",   3, "If pm_smokegran_allow is enabled you can set the number of Smokegrenades that the Premium User will get")
pm_helmet_allow = config.cvar("pm_helmet_allow",   1, "1 = Enable 0 = Disable  Here you can set if You want to allow Premium Users to Get Free Helmet and Suits")
pm_deagle_allow = config.cvar("pm_deagle_allow",   1, "1 = Enable 0 = Disable  Here you can set if You want to allow Premium Users to Get Free Pistol at Spawn")
pm_deagle_weapon = config.cvar("pm_deagle_weapon",   'weapon_deagle', "if pm_deagle_allow is enabled you can set here the pistol name that you want to give Premium User")
pm_weapongive_allow = config.cvar("pm_weapongive_allow",   1, "1 = Enable 0 = Disable  Here you can set if You want to allow Premium Users to Get Free Machine Guns at Spawn")
pm_weapongive_weapon_t = config.cvar("pm_weapongive_weapon_t",   'weapon_ak47', "if pm_weapongive_allow is enabled you can set here the weapon name that you want to give Premium User (FOR TERRORISTS)")
pm_weapongive_weapon_ct = config.cvar("pm_weapongive_weapon_ct",   'weapon_m4a1', "if pm_weapongive_allow is enabled you can set here the weapon name that you want to give Premium User(FOR COUNTERTERRORISTS)")
pm_weapongive_giveonlywhenplayerwasdeath = config.cvar("pm_weapongive_giveonlywhenplayerwasdeath",   0, "if pm_weapongive_allow is enabled you can set here if you don't want to give Users the new Weapons when they didn't die (Only when they were death)")
pm_laser_allow = config.cvar("pm_laser_allow",   1, "Here you can set if You want to allow Premium Users to Shoot with Lasers")
pm_hitsparks_allow = config.cvar("pm_hitsparks_allow",   1, "1 = Enable 0 = Disable  Here you can set if You want to allow Premium Users to Creat HitSparks")
pm_enemydisplay_allow = config.cvar("pm_enemydisplay_allow",   1, "1 = Enable 0 = Disable  Here you can set if You want to allow Premium Users to See How long is the Distance to the nearest Enemy")
pm_dissolve_allow = config.cvar("pm_dissolve_allow",   1, "1 = Enable 0 = Disable  Here you can set if You want to allow Premium Users to Dissolve There Enemys Body on Death")
pm_hegran_allow = config.cvar("pm_hegran_allow",   1, "1 = Enable 0 = Disable Here you can set if You want to allow Premium Users to Use More Hegrenades")
pm_hegran_var = config.cvar("pm_hegran_var",   3, "If pm_hegran_allow is enabled you can set the number of Hegrenades that the Premium User will get")
pm_grantrail_allow = config.cvar("pm_grantrail_allow",   1, "1 = Enable 0 = Disable  Here you can set if You want to allow Premium Users to Have Grenades Trails when they throw any nades")
pm_vip_logo = config.cvar("pm_vip_logo",   1, "1 = Enable 0 = Disable  Here you can set if You want to allow Premium Users to Use VIP Loogos above their heads")
pm_tag_enable = config.cvar("pm_tag_enable",   1, "1 = Enable 0 = Disable  Here you can set if You want to allow Premium Users to Chat with VIP Tag")
pm_tag_text = config.cvar("pm_tag_text",   '[Premium User]', "If pm_tag_enable is enabled you can set here the Name of Tag")
pm_weapons_enable = config.cvar("pm_weapons_enable",   1, "1 = Enable 0 = Disable  Here you can set if You want to allow Premium Users to Get Free Weapons via Menu")
pm_weapons_force = config.cvar("pm_weapons_force",   '!guns', "If pm_weapons_enable is enabled you can set the Chatcommand to Open Gunmenu")
pm_antiflash_allow = config.cvar("pm_antiflash_allow",   1, "If You want to Allow Premium User to get not flashed when their own Flasbangs detonades")
pm_trails_allow = config.cvar("pm_trails_allow",   1, "If You want to Allow Premium User to Get Player Trails on Movement")
pm_trails_colors = config.cvar("pm_trails_colors",  '255,0,0', "If pm_trails_allow is enabled you can set the color of Playertrails")
pm_gransparks_allow = config.cvar("pm_gransparks_allow",  1, "If You want to allow Premium Users to Have Grenade Sparks on Detonade")
pm_skin_allow = config.cvar("pm_skin_allow", 1, "1 = Allow PremiumUsers to use Skins")
pm_skin_force = config.cvar("pm_skin_force", '!skins', "Here you can set the command to force to open skinmenu")
config.write()

config.execute()

try:
	conn = pymysql.connect(host=str(pm_host_set),user=str(pm_host_user),passwd=str(pm_host_userpw), db=str(pm_host_userdb))
	cursor = conn.cursor()
	es.dbgmsg(0, "[PremiumMod] Succsessgfull Connected to your Database.")
except:
	raise NotImplementedError, "[PremiumMod] The Addon is not able to Connect to your Database. Check your Datas again please !"
	

################################Addon Infos##########################################
info = es.AddonInfo()                                                               #
info.name          = 'PremiumMod'                                                   #
info.version       = '1.8 A'                                                        #
info.basename      = 'pm_mod'                                                       #
info.url           = 'http://addons.eventscripts.com/addons/view/PremiumMod2'       #
info.author        = 'RoOF'                                                         #
es.ServerVar(info.basename, info.version, 'PremiumMod').makepublic()                #
#####################################################################################


def load():
	global menu, setup_dict, restrictedList, text
	download()
	text = langlib.Strings(apath + "/strings.ini")
	es.doblock('corelib/noisy_on')
	database_pm = apath + '/database.db'
	if os.path.isfile(database_pm):
		file_players = open(database_pm)
		setup_dict = cPickle.load(file_players)
		file_players.close() 
		es.server.queuecmd('sv_hudhint_sound 0')
	if pm_awp_allow == 1:
		restrictedList = str(restricted).split(';')
		es.addons.registerClientCommandFilter(restrict)
	if pm_prmessage_allow == 1:
		es.addons.registerSayFilter(prchatfilter)
	if pm_tag_enable == 1:
		es.addons.registerSayFilter(PremiumTalk)
	for userid in es.getUseridList():
		disableAutokick(userid)
	if es.ServerVar('eventscripts_currentmap') != '':
		global precache1, premodel
		precache1 = es.precachemodel("materials/sprites/laserbeam.vmt")
		premodel = es.precachemodel('effects/laser1.vmt')
	if outofdateannounce == 1:
		d = os.path.isfile(apath + "/ADDON_IS_OUT_OF_DATE.txt")
		if needupdate():
			es.dbgmsg(0, "[PremiumMod] A newer Version for this Addon is available. Visit %s" % info["url"])
			if not d:
				b = open(apath + "/ADDON_IS_OUT_OF_DATE.txt", "wb")
				b.write("You can update this Addon here:\n %s" % info["url"])
				b.close()
		else:
			if d:
				os.remove(apath + "/ADDON_IS_OUT_OF_DATE.txt")
		
def unload():
	save()
	es.doblock('corelib/noisy_off')
	if pm_chicken_allow == 1:
		gamethread.cancelDelayed('chicken')
		del chickenlist[:]
		del chickenlist2[:]
	if pm_zombie_allow == 1:
		gamethread.cancelDelayed('zombie')
		del zombielist[:]
		del zombielist2[:]
	if pm_awp_allow == 1:
		es.addons.unregisterClientCommandFilter(restrict)
	if pm_prmessage_allow == 1:
		es.addons.unregisterSayFilter(prchatfilter)
	if pm_grantrail_allow == 1:
		ticker.reset()
	if pm_tag_enable == 1:
		es.addons.unregisterSayFilter(PremiumTalk)
	if pm_trails_allow == 1:
		for userid in es.getUseridList():
			gamethread.cancelDelayed('trail_%s' % userid)
	damageTaken.clear()
	del restrictedList[:]
	del featuresList[:]
	del saveWeapon[:]
	playerinfo.clear()

	
def threading_t(steam):
	with threading.Lock():
		cursor.execute("SELECT `steamid` FROM `_TBL` WHERE `steamid` = '%s'" % steam)
		y = cursor.execute("SELECT `steamid` FROM `_TBL` WHERE `steamid` = '%s'" % steam)
		if y:
			featuresList.append(steam)
			cursor.execute("SELECT `expire`, `playername`, `email` FROM `_TBL` WHERE `steamid` = '%s'"% steam)
			result = cursor.fetchone()
			playerinfo[steam] = {}
			playerinfo[steam]['expire'] = result[0]
			playerinfo[steam]['name'] = result[1]
			playerinfo[steam]['email'] = result[2]
			setup_dict[steam] = {}
			if pm_message_allow != 0:
				if 'Personal Welcome Message' not in setup_dict[steam]:
					setup_dict[steam]['Personal Welcome Message'] = 0
			if pm_reserve_allow != 0:
				if 'One Reserved Slot' not in setup_dict[steam]:
					setup_dict[steam]['One Reserved Slot'] = 0
			if pm_chicken_allow != 0:
				if 'Play as Chicken' not in setup_dict[steam]:
					setup_dict[steam]['Play as Chicken'] = 0
			if pm_zombie_allow != 0:
				if 'Play as Zombie' not in setup_dict[steam]:
					setup_dict[steam]['Play as Zombie'] = 0
			if pm_awp_allow != 0:
				if 'Play with AWP and Auto-Sniper' not in setup_dict[steam]:
					setup_dict[steam]['Play with AWP and Auto-Sniper'] = 0
			if pm_speed_allow != 0:
				if 'More Speed' not in setup_dict[steam]:
					setup_dict[steam]['More Speed'] = 0
			if pm_uammo_allow != 0:
				if 'Unlimited Ammo' not in setup_dict[steam]:
					setup_dict[steam]['Unlimited Ammo'] = 0
			if pm_prmessage_allow != 0:
				if 'Read Private Chat of Enemy Team' not in setup_dict[steam]:
					setup_dict[steam]['Read Private Chat of Enemy Team'] = 0
			if pm_killassist_allow != 0:
				if 'Kill Assist' not in setup_dict[steam]:
					setup_dict[steam]['Kill Assist'] = 0
			if pm_healthbonus_allow != 0:
				if 'Health Bonus' not in setup_dict[steam]:
					setup_dict[steam]['Health Bonus'] = 0
			if pm_vampnade_allow != 0:
				if 'Vampire Grenades' not in setup_dict[steam]:
					setup_dict[steam]['Vampire Grenades'] = 0
			if pm_respawn_allow != 0:
				if 'Respawn Chance' not in setup_dict[steam]:
					setup_dict[steam]['Respawn Chance'] = 0
			if pm_nofalldmg_allow != 0:
				if 'No Fall damage' not in setup_dict[steam]:
					setup_dict[steam]['No Fall damage'] = 0
			if pm_noowndmg_allow != 0:
				if 'No Damage by own HE Grenades' not in setup_dict[steam]:
					setup_dict[steam]['No Damage by own HE Grenades'] = 0
			if pm_cash_allow != 0:
				if 'More Cash' not in setup_dict[steam]:
					setup_dict[steam]['More Cash'] = 0
			if pm_flashbang_allow != 0:
				if '%s Flashbangs'% pm_flashbang_var not in setup_dict[steam]:
					setup_dict[steam]['%s Flashbangs'% pm_flashbang_var] = 0
			if pm_smokegran_allow != 0:
				if '%s Smoke Grenades'% pm_smokegran_var not in setup_dict[steam]:
					setup_dict[steam]['%s Smoke Grenades'% pm_smokegran_var] = 0
			if pm_helmet_allow != 0:
				if 'One Kevlar and One Helmet' not in setup_dict[steam]:
					setup_dict[steam]['One Kevlar and One Helmet'] = 0
			if pm_deagle_allow != 0:
				if 'Give %s'% str(pm_deagle_weapon).replace('weapon_', '').upper() not in setup_dict[steam]:
					setup_dict[steam]['Give %s'% str(pm_deagle_weapon).replace('weapon_', '').upper()] = 0
			if pm_weapongive_allow != 0:
				if 'Give %s (T) or %s (CT)'% (str(pm_weapongive_weapon_t).replace('weapon_', '').upper(), str(pm_weapongive_weapon_ct).replace('weapon_', '').upper()) not in setup_dict[steam]:
					setup_dict[steam]['Give %s (T) or %s (CT)'% (str(pm_weapongive_weapon_t).replace('weapon_', '').upper(), str(pm_weapongive_weapon_ct).replace('weapon_', '').upper())] = 0
			if pm_laser_allow != 0:
				if 'Bullet Lasers' not in setup_dict[steam]:
					setup_dict[steam]['Bullet Lasers'] = 0
			if pm_hitsparks_allow != 0:
				if 'Bullet Hit Sparks' not in setup_dict[steam]:
					setup_dict[steam]['Bullet Hit Sparks'] = 0
			if pm_enemydisplay_allow != 0:
				if 'Show the nearest Enemy' not in setup_dict[steam]:
					setup_dict[steam]['Show the nearest Enemy'] = 0
			if pm_dissolve_allow != 0:
				if 'Dissolving Victim Ragdolls' not in setup_dict[steam]:
					setup_dict[steam]['Dissolving Victim Ragdolls'] = 0
			if pm_hegran_allow != 0:
				if '%s HE grenades'% pm_hegran_var not in setup_dict[steam]:
					setup_dict[steam]['%s HE grenades'% pm_hegran_var] = 0
			if pm_grantrail_allow != 0:
				if 'Grenade Trails' not in setup_dict[steam]:
					setup_dict[steam]['Grenade Trails'] = 0
			if pm_vip_logo != 0:
				if 'VIP Logo' not in setup_dict[steam]:
					setup_dict[steam]['VIP Logo'] = 0
			if pm_tag_enable != 0:
				if 'VIP Tag Chat' not in setup_dict[steam]:
					setup_dict[steam]['VIP Tag Chat'] = 0
			if pm_weapons_enable != 0:
				if 'Give Weapons' not in setup_dict[steam]:
					setup_dict[steam]['Give Weapons'] = 0
			if pm_sound_allow != 0:
				if 'Play Sound on Connect' not in setup_dict[steam]:
					setup_dict[steam]['Play Sound on Connect'] = 0
			if pm_antiflash_allow != 0:
				if 'Anti Flash by Own Flashbangs' not in setup_dict[steam]:
					setup_dict[steam]['Anti Flash by Own Flashbangs'] = 0
			if pm_trails_allow != 0:
				if 'Player Trails' not in setup_dict[steam]:
					setup_dict[steam]['Player Trails'] = 0
			if pm_gransparks_allow != 0:
				if 'Grenade Sparks' not in setup_dict[steam]:
					setup_dict[steam]['Grenade Sparks'] = 0
			if pm_skin_allow != 0:
				if 'Set Skin' not in setup_dict[steam]:
					setup_dict[steam]['Set Skin'] = 0
				save()
	


def player_activate(ev):
	global featuresList
	steam = ev['es_steamid']
	disableAutokick(ev['userid'])
	td = threading.Thread(target=threading_t(steam))
	td.start()
	if pm_message_allow == 1:
		if setup_dict.has_key(steam):
			if setup_dict[steam]['Personal Welcome Message'] == 0:
				for useridx in es.getUseridList():
					es.tell(useridx, '#multi', text('pm_conn',{'v1': es.getplayername(ev['userid'])},playerlib.getPlayer(useridx).get('lang')))
					if pm_sound_allow == 1:
						if setup_dict.has_key(steam):
							if setup_dict[steam]['Play Sound on Connect'] == 0:
								es.playsound(useridx, pm_sound_path,"1.0")
	if steam not in featuresList:
		if steam in setup_dict:
			es.tell(ev['userid'], '#multi', text('pm_removed',{},playerlib.getPlayer(ev['userid']).get('lang')))
			del setup_dict[steam]
		
def player_say(ev):
	text2 = ev['text']
	userid = int(ev['userid'])
	steam = ev['es_steamid']
	if userid != 0:
		player = playerlib.getPlayer(userid)
	if text2 == pm_force_pm:
		if steam in featuresList:
			infomenu(userid)
		else:
			es.tell(userid, '#multi', text('notallowed',{},player.get('lang')))
	if text2 == pm_skin_force:
		if steam in featuresList:
			modelfeatures(userid)
		else:
			es.tell(userid, '#multi', text('notallowed',{},player.get('lang')))
	if text2 == pm_chicken_force:
		if pm_chicken_allow == 1:
			if setup_dict.has_key(steam):
				if steam in featuresList:
					if setup_dict[steam]['Play as Chicken'] == 0:
						if steam not in chickenlist:
							if steam not in zombielist:
								chickenlist.append(steam)
								for useridx in es.getUseridList():
									es.tell(useridx, '#multi', text('chickenforce',{'v1': es.getplayername(userid)},playerlib.getPlayer(useridx).get('lang')))
							else:
								es.tell(userid, text('playalreadyzm',{},player.get('lang')))			
						else:
							es.tell(userid, text('playalreadych',{},player.get('lang')))
							
			else:
				es.tell(userid, '#multi', text('notallowed',{},player.get('lang')))
	if text2 == pm_zombie_force:
		if pm_zombie_allow == 1:
			if steam in featuresList:
				if setup_dict.has_key(steam):
					if setup_dict[steam]['Play as Zombie'] == 0:
						if steam not in zombielist:
							if steam not in chickenlist:
								zombielist.append(steam)
								for useridx in es.getUseridList():
									es.tell(useridx, '#multi', text('zombieforce',{'v1': es.getplayername(userid)},playerlib.getPlayer(useridx).get('lang')))
							else:
								es.tell(userid, text('playalreadych',{},player.get('lang')))
						else:
							es.tell(userid, text('playalreadyzm',{},player.get('lang')))
				else:
					es.tell(userid, '#multi', text('notallowed',{},player.get('lang')))
	if text2 == pm_weapons_force:
		if pm_weapons_enable == 1:
			if steam in featuresList:
				if setup_dict.has_key(steam):
					if setup_dict[steam]['Give Weapons'] == 0:
						weapongiver(userid)
				else:
					es.tell(userid, '#multi', text('notallowed',{},player.get('lang')))
		
							
def save():
	file_players = open(apath + '/database.db','w')
	cPickle.dump(setup_dict, file_players)
	file_players.close()
	
def player_spawn(ev):
	userid = int(ev['userid'])
	steam = ev['es_steamid']
	team = ev['es_userteam']
	player = playerlib.getPlayer(userid)
	if steam in featuresList:
		if not es.getplayerprop(userid, "CCSPlayer.baseclass.pl.deadflag"):
			if setup_dict.has_key(steam):
				if pm_cash_allow == 1:
					if setup_dict[steam]['More Cash'] == 0:
						es.setplayerprop(userid, 'CCSPlayer.m_iAccount', pm_cash_var)
				if pm_flashbang_allow == 1:
					if setup_dict[steam]['%s Flashbangs'% pm_flashbang_var] == 0:
						es.delayed(0.2, 'es_xgive %s %s'%(userid, 'weapon_flashbang'))
						player.setAmmo('weapon_flashbang', pm_flashbang_var)
				if pm_smokegran_allow == 1:
					if setup_dict[steam]['%s Smoke Grenades'% pm_smokegran_var] == 0:
						es.delayed(0.2, 'es_xgive %s %s'%(userid, 'weapon_smokegrenade'))
						player.setAmmo('weapon_smokegrenade', pm_smokegran_var)
				if pm_hegran_allow == 1:
					if setup_dict[steam]['%s HE grenades'% pm_hegran_var] == 0:
						es.delayed(0.2, 'es_xgive %s %s'%(userid, 'weapon_hegrenade'))
						player.setAmmo('weapon_hegrenade', pm_hegran_var)
				if pm_helmet_allow == 1:
					if setup_dict[steam]['One Kevlar and One Helmet'] == 0:
						es.delayed(0.2, 'es_xgive %s %s'%(userid, 'item_assaultsuit'))
				if pm_deagle_allow == 1:
					if steam not in saveWeapon:
						if setup_dict[steam]['Give %s'% str(pm_deagle_weapon).replace('weapon_', '').upper()] == 0:
							weapon = player.getSecondary()
							if weapon != pm_deagle_weapon:
								es.delayed(0.2,"es_xremove %s" % weapon)
								es.delayed(0.4,'es_xgive %s %s' % (userid, pm_deagle_weapon))
								if pm_uammo_allow == 1:
									if setup_dict[steam]['Unlimited Ammo'] == 0:
										player.setAmmo(pm_deagle_weapon, 200)
					else:
						if player.getSecondary():
							player.setAmmo(player.getSecondary(), 200)
				if pm_weapongive_allow == 1:
					if steam not in saveWeapon:
						if setup_dict[steam]['Give %s (T) or %s (CT)' % (str(pm_weapongive_weapon_t).replace('weapon_', '').upper(), str(pm_weapongive_weapon_ct).replace('weapon_', '').upper())] == 0:
							weapon = player.getPrimary()
							if es.getplayerteam(userid) == 2:
								if weapon != pm_weapongive_weapon_t:
									es.delayed(0.1, "es_xremove %s"% weapon)
									es.delayed(0.4, 'es_xgive %s %s'%(userid, pm_weapongive_weapon_t))
									if pm_uammo_allow == 1:
										if setup_dict[steam]['Unlimited Ammo'] == 0:
											player.setAmmo(pm_weapongive_weapon_t, 200)
							else:
								if weapon != pm_weapongive_weapon_ct:
									es.delayed(0.2,"es_xremove %s"% weapon)
									es.delayed(0.4, 'es_xgive %s %s'%(userid, pm_weapongive_weapon_ct))
									if pm_uammo_allow == 1:
										if setup_dict[steam]['Unlimited Ammo'] == 0:
											player.setAmmo(pm_weapongive_weapon_ct, 200)
					else:
						if player.getPrimary():
							player.setAmmo(player.getPrimary(), 200)
				if pm_vip_logo == 1:
					if setup_dict[steam]['VIP Logo'] == 0:
						if steam not in chickenlist:
							if steam not in zombielist:
								gamename = es.getGameName()
								eye_angles12 = {'cstrike': 'CCSPlayer.m_angEyeAngles[%s]'}
								eye_angles = tuple(es.getplayerprop(userid, eye_angles12[gamename] % x) for x in (0, 1))
								es.server.queuecmd('es_xsetang %s 90 0 0' % userid)
								es.server.queuecmd('es_xprop_dynamic_create %(userid)s "extras/frown/info_speech.mdl";es_xentsetname %(userid)s vip_%(userid)s' % {'userid': userid})
								location = es.getplayerlocation(userid)
								es.server.queuecmd('es_xfire %s vip_%s addoutput "origin %s %s %s"' % (userid, userid, location[0], location[1], location[2] + 96))
								es.server.queuecmd('es_xfire %(userid)s vip_%(userid)s SetParent !activator;es_xfire %(userid)s vip_%(userid)s SetAnimation idle;es_xfire %(userid)s vip_%(userid)s addoutput "angles 0 0 0";es_xfire %(userid)s vip_%(userid)s addoutput "solid 0"' % {'userid': userid})
								es.server.queuecmd('es_xsetang %s %s %s 0'% ((userid,) + eye_angles))
				if pm_speed_allow == 1:
					if setup_dict[steam]['More Speed'] == 0:
						player.speed = pm_speed_var
				if pm_skin_allow == 1:
					change_skin_pm(userid, steam)
				if pm_trails_allow == 1:
					if setup_dict[steam]['Player Trails'] == 0:
						gamethread.delayedname(0.1, 'trail_%s'% userid, start,(userid))
				if pm_healthbonus_allow == 1:
					if setup_dict[steam]['Health Bonus'] == 0:
						player.health += pm_healthbonus_var
				if pm_chicken_allow == 1:
					if steam in chickenlist:
						player.health = pm_chicken_hp
						gamethread.delayed(0.3, es.server.queuecmd, 'es_xfire %s player_weaponstrip strip' % userid)
						gamethread.delayed(0.3, es.server.queuecmd, 'es_xfire %s player_weaponstrip kill' % userid)
						es.delayed(0.4,'es_xgive %s %s' % (userid, "weapon_knife"))
						es.emitsound("player", userid, "premiumMod/chicken_start.mp3", 1.0, 0.8)
						player.setModel('models/lduke/chicken/chicken3.mdl')
						chickenlist2.append(steam)
						chickenlist.remove(steam)
						chickenmod(userid, steam)
				if pm_zombie_allow == 1:
					if steam in zombielist:
						player.health = pm_zombie_hp
						gamethread.delayed(0.3, es.server.queuecmd, 'es_xfire %s player_weaponstrip strip' % userid)
						gamethread.delayed(0.3, es.server.queuecmd, 'es_xfire %s player_weaponstrip kill' % userid)
						es.delayed(0.4,'es_xgive %s %s' % (userid, "weapon_knife"))
						zombielist2.append(steam)
						zombielist.remove(steam)
						es.emitsound("player", userid, "premiumMod/zidle3.mp3", 1.0, 0.8)
						zmskin = random.randint(1, 2)
						if zmskin == 1:
							player.setModel('models/player/zh/zh_corpse002.mdl')
						elif zmskin == 2:
							player.setModel('models/player/zh/zh_zombie003.mdl')
						zombiemod(userid, steam)
				es.tell(userid, '#multi', text('pm_spawnmessage',{'v1': player.health,'v2': player.cash},player.get('lang')))

				
def weapon_fire_on_empty(ev):
	steam = ev['es_steamid']
	if pm_uammo_allow == 1:
		if pm_uammo_type == 1:
			if steam in featuresList:
				if setup_dict.has_key(steam):
					if setup_dict[steam]['Unlimited Ammo'] == 0:
						userid = int(ev['userid'])
						weapon = ev['weapon']
						playerlib.getPlayer(userid).setAmmo(weapon, 200)
						playerlib.getPlayer(userid).setClip(weapon, 30)


def player_death(ev):
	asteam = ev['es_attackersteamid']
	steam = ev['es_steamid']
	auserid = int(ev['attacker'])
	userid = int(ev['userid'])
	if asteam in featuresList:
		if setup_dict.has_key(asteam):
			if pm_healthbonus_allow == 1:
				if ev['es_userteam'] != ev['es_attackerteam']:
					if setup_dict[asteam]['Health Bonus'] == 0:
						playerlib.getPlayer(auserid).health += pm_killhbonus_var
						es.tell(auserid, '#multi', text('pm_killbonus',{'v1':pm_killhbonus_var,'v2': es.getplayername(userid)},playerlib.getPlayer(auserid).get('lang')))
			if pm_dissolve_allow == 1:
				if auserid != userid:
					if setup_dict[asteam]['Dissolving Victim Ragdolls'] == 0:
						es.server.queuecmd('es_xfire %s cs_ragdoll kill' % userid)
	if steam in featuresList:
		if pm_respawn_allow == 1:
			if setup_dict.has_key(steam):
				if setup_dict[steam]['Respawn Chance'] == 0:
					r = random.randint(1, 100)
					if r >= pm_respawn_chance:
						respawn(userid)
		if pm_trails_allow == 1:
			if steam in setup_dict:
				if setup_dict[steam]['Player Trails'] == 0:
					gamethread.cancelDelayed('trail_%s'% userid)
	if pm_killassist_allow == 1:
		if userid in damageTaken:
			for playerid in damageTaken[userid]:
				if playerid != 0:
					if playerid == auserid:
						continue
					es.server.queuecmd('score add %s 1'% playerid)
					es.tell(playerid, '#multi', text('assistend',{'v1': es.getplayername(userid)},playerlib.getPlayer(playerid).get('lang')))
				del damageTaken[userid]
	if pm_zombie_allow == 1:
		if asteam in zombielist2:
			es.emitsound("player", auserid, "premiumMod/zidle3.mp3", 1.0, 0.8)
		if steam in zombielist2:
			zombielist2.remove(steam)
	if pm_chicken_allow == 1:
		if asteam in chickenlist2:
			es.emitsound("player", userid, "premiumMod/chicken_kill.mp3", 1.0, 0.8)
		if steam in chickenlist2:
			chickenlist2.remove(steam)
		if pm_vip_logo == 1:
			if setup_dict.has_key(steam):
				if setup_dict[steam]['VIP Logo'] == 0:	
					es.server.queuecmd('es_xfire %s vip_%s kill' % (userid, userid))
		if pm_weapongive_giveonlywhenplayerwasdeath == 1:
			if steam in saveWeapon:
				saveWeapon.remove(steam)



def player_hurt(ev):
	weapon = ev['weapon']
	asteam = ev['es_attackersteamid']
	steam = ev['es_steamid']
	userid = int(ev['userid'])
	auserid = int(ev['attacker'])
	if asteam in featuresList:
		if auserid == 0:
			return
		if setup_dict.has_key(asteam):
			if weapon == 'hegrenade':
				if pm_vampnade_allow == 1:
					if setup_dict[asteam]['Vampire Grenades'] == 0:
						if auserid != userid:
							if int(ev['dmg_health']) == 0:
								return
							damage = int(ev['dmg_health'])*(pm_vampnade_percent/100)
							playerlib.getPlayer(auserid).health += round(damage)
							es.tell(auserid, '#multi', text('pm_hurtwithhe',{'v1': int(round(damage))},playerlib.getPlayer(auserid).get('lang')))
						else:
							if pm_noowndmg_allow == 1:
								if setup_dict[asteam]['No Damage by own HE Grenades'] == 0:
									playerlib.getPlayer(auserid).health += int(ev['dmg_health'])
			if pm_killassist_allow == 1:
				if setup_dict[asteam]['Kill Assist'] == 0:
					if userid != auserid:
						if ev['es_userteam'] != ev['es_attackerteam']:
							if not userid in damageTaken:
								damageTaken[userid] = []
							if not auserid in damageTaken[userid]:
								damageTaken[userid].append(auserid)
	if pm_zombie_allow == 1:
		if steam in zombielist2:
			zmsound = random.randint(1, 4)
			if zmsound == 1:
				es.emitsound("player", userid, "premiumMod/zidle1.mp3", 1.0, 0.8)
			elif zmsound == 2:
				es.emitsound("player", userid, "premiumMod/zidle2.mp3", 1.0, 0.8)
			elif zmsound == 3:
				es.emitsound("player", userid, "premiumMod/zidle3.mp3", 1.0, 0.8)
			elif zmsound == 4:
				es.emitsound("player", userid, "premiumMod/zidle4.mp3", 1.0, 0.8)
		
def weapon_fire(ev):
	global weaponvector
	weapon = ev['weapon']
	steam = ev['es_steamid']
	userid = int(ev['userid'])
	if steam in featuresList:
		if setup_dict.has_key(steam):
			if pm_laser_allow == 1:
				if setup_dict[steam]['Bullet Lasers'] == 0:
					x,y,z = es.getplayerlocation(userid)
					if es.getplayerprop(userid, 'CBasePlayer.localdata.m_Local.m_bDucked') % 2:
						z = z + 44
					else:
						z = z + 64
					weaponvector = es.createvectorstring(x,y,z)
			if pm_grantrail_allow == 1:
				if setup_dict[steam]['Grenade Trails'] == 0:
					if weapon == 'hegrenade' or 'flashbang' or 'smokegrenade':
						ticker.start()
			if pm_uammo_allow == 1:
				if pm_uammo_type == 2:
					if setup_dict[steam]['Unlimited Ammo'] == 0:
						w = weaponlib.getWeapon(weapon)
						p = playerlib.getPlayer(userid)
						p.setClip(weapon, w['clip'])
			
					
def hegrenade_detonate(ev):
	steam = ev['es_steamid']
	if steam in featuresList:
		if pm_grantrail_allow == 1:
			if setup_dict.has_key(steam):
				if setup_dict[steam]['Grenade Trails'] == 0:
					gamethread.delayed(0.1, ticker.stop)
		if pm_gransparks_allow == 1:
			if setup_dict.has_key(steam):
				if setup_dict[steam]['Grenade Sparks'] == 0:
					es.server.queuecmd("es_xeffect sparks %s 8 8 0,0,0" % es.createvectorstring(ev["x"],ev["y"],ev["z"]))
				
def flashbang_detonate(ev):
	steam = ev['es_steamid']
	if steam in featuresList:
		if pm_grantrail_allow == 1:
			if setup_dict.has_key(steam):
				if setup_dict[steam]['Grenade Trails'] == 0:
					gamethread.delayed(0.1, ticker.stop)
		if pm_antiflash_allow == 1:
			if setup_dict.has_key(steam):
				if setup_dict[steam]['Anti Flash by Own Flashbangs'] == 0:
					es.setplayerprop(int(ev['userid']), "CCSPlayer.m_flFlashDuration", 0)
		if pm_gransparks_allow == 1:
			if setup_dict.has_key(steam):
				if setup_dict[steam]['Grenade Sparks'] == 0:
					es.server.queuecmd("es_xeffect sparks %s 8 8 0,0,0" % es.createvectorstring(ev["x"],ev["y"],ev["z"]))
				
def smokegrenade_detonate(ev):
	steam = ev['es_steamid']
	if steam in featuresList:
		if pm_grantrail_allow == 1:
			if setup_dict.has_key(steam):
				if setup_dict[steam]['Grenade Trails'] == 0:
					gamethread.delayed(0.1, ticker.stop)
		if pm_gransparks_allow == 1:
			if setup_dict.has_key(steam):
				if setup_dict[steam]['Grenade Sparks'] == 0:
					es.server.queuecmd("es_xeffect sparks %s 8 8 0,0,0" % es.createvectorstring(ev["x"],ev["y"],ev["z"]))
					
def weapon_reload(ev):
	steam = ev['es_steamid']
	userid = int(ev['userid'])
	weapon = ev['es_userweapon']
	if steam in featuresList:
		if pm_uammo_allow == 1:
			if pm_uammo_type == 1:
				if setup_dict.has_key(steam):
					if setup_dict[steam]['Unlimited Ammo'] == 0:
						x = playerlib.getPlayer(userid).getClip(weapon)
						x2 = 30 - x
						playerlib.getPlayer(userid).setAmmo(weapon, 200 + x2)
	
def round_start(ev):
	for useridx in es.getUseridList():
		gamethread.delayed(4, es.tell,(useridx, '#multi', text('round_msg',{'v1': URL},playerlib.getPlayer(useridx).get('lang'))))

						
def round_end(ev):
	ticker.reset()
	for userid in es.getUseridList():
		steam = es.getplayersteamid(userid)
		if pm_chicken_allow == 1:
			if steam in chickenlist2:
				chickenlist2.remove(steam)
				gamethread.cancelDelayed('chicken')
		if pm_zombie_allow == 1:
			if steam in zombielist2:
				zombielist2.remove(steam)
				gamethread.cancelDelayed('zombie')
		if pm_weapongive_giveonlywhenplayerwasdeath == 1:
			if not es.getplayerprop(userid, "CCSPlayer.baseclass.pl.deadflag"):
				if steam not in saveWeapon:
					saveWeapon.append(steam)


				
def player_disconnect(ev):
	steam = ev['networkid']
	if steam in featuresList:
		save()
	if steam in chickenlist:
		chickenlist.remove(steam)
	if steam in zombielist:
		zombielist.remove(steam)
	if steam in chickenlist2:
		chickenlist2.remove(steam)
	if steam in zombielist2:
		zombielist2.remove(steam)
	if steam in saveWeapon:
		saveWeapon.remove(steam)
	if steam in playerinfo:
		del playerinfo[steam]

		
def es_map_start(ev):
	global precache1, premodel
	download()
	createSteamList()
	precache1 = es.precachemodel("materials/sprites/laserbeam.vmt")
	premodel = es.precachemodel('effects/laser1.vmt')
	ticker.reset()
	
	
def player_connect(ev):
	if pm_reserve_allow == 1:
		if es.getplayercount() != es.getmaxplayercount() - 1:
			return
		steam = ev['networkid']
		userid = ev['userid']
		if not steam in featuresList:
			es.server.queuecmd('kickid ' + userid)
		else:
			if setup_dict.has_key(steam):
				if setup_dict[steam]['One Reserved Slot'] == 0:
					kick_player = get_player_to_kick()
					if kick_player is None:
						es.server.queuecmd('kickid ' + userid)
					else:
						es.server.queuecmd('kickid %s' % kick_player)

def get_player_to_kick():
	for userid in es.getUseridList():
		if not es.getplayersteamid(userid) in featuresList:
			return userid
	return None
	
						
def bullet_impact(ev):
	global weaponvector, premodel
	steam = ev['es_steamid']
	userid = int(ev['userid'])
	if steam in featuresList:
		if setup_dict.has_key(steam):
			if pm_laser_allow == 1:
				if setup_dict[steam]['Bullet Lasers'] == 0:
					weaponvector2 = es.createvectorstring(ev["x"],ev["y"],ev["z"])
					if es.getplayerteam(userid) == 3:
						es.server.queuecmd("es_xeffect beam %s %s %s %s 0 0.2 0.1 6 6 0 0 0 0 255 255 100" % (weaponvector, weaponvector2, premodel, premodel))
					else:
						es.server.queuecmd("es_xeffect beam %s %s %s %s  0 0.2 0.1 6 6 0 0 255 0 0 255 100" % (weaponvector, weaponvector2, premodel, premodel))
			if pm_hitsparks_allow == 1:
				if setup_dict[steam]['Bullet Lasers'] == 0:
					es.server.queuecmd("es_xeffect sparks %s 1 1 0,0,0" % es.createvectorstring(ev["x"],ev["y"],ev["z"]))

def needupdate():
	a = esamlib.getAddon("PremiumMod2")
	try:
		curver = a.currentversion
	except:
		return False
	else:
		if curver != info["version"]:
			return True
	return False
	
def check((x2,y2,z2), userid):
	if not es.getplayerprop(userid, "CCSPlayer.baseclass.pl.deadflag"):
		x,y,z = es.getplayerlocation(userid)
		gamethread.cancelDelayed('trail_%s' % userid)
		if (x,y,z) != (x2,y2,z2):
			r,g,b = str(pm_trails_colors).split(',')
			effectlib.drawLine((x2,y2,z2 + 40), (x,y,z + 40), 'materials/sprites/laserbeam.vmt', 'materials/sprites/halo01.vmt', 1,
			10, 10, r, g, b, 155, speed=5, fadelength=100, noise=0, framestart=0, framerate=0)
			(x2,y2,z2) = x,y,z
		gamethread.delayedname(0, 'trail_%s'% userid, check,((x2,y2,z2), userid))
	
def start(userid):
	gamethread.delayedname(0.02, 'trail_%s'% userid, check,(es.getplayerlocation(userid), userid))
			

def chickenmod(userid, steam):
	if steam in chickenlist2:
		 if playerlib.getPlayer(userid).health <= pm_chicken_hp:
			playerlib.getPlayer(userid).health += pm_chicken_regeneration
	gamethread.delayedname(1, 'chicken', chickenmod,(userid, steam))
	
def zombiemod(userid, steam):
	if steam in zombielist2:
		 if playerlib.getPlayer(userid).health <= pm_zombie_hp:
			playerlib.getPlayer(userid).health += pm_zombie_regeneration
	gamethread.delayedname(1, 'zombie', zombiemod,(userid, steam))
	
def player_falldamage(ev):
	if pm_nofalldmg_allow == 1:
		steam = ev['es_steamid']
		if steam in setup_dict:
			if setup_dict[steam]['No Fall damage'] == 0:
				playerlib.getPlayer(ev['userid']).health += float(ev['damage'])
	
def restrict(userid, args):
	steam = es.getplayersteamid(userid)
	if args[0].lower() == "buy":
		if steam not in featuresList:
			if args[1].lower() in restrictedList:
				es.playsound(userid, "buttons/weapon_cant_buy.wav", 1.0)
				es.tell(userid, '#multi', text('res',{},playerlib.getPlayer(userid).get('lang')))
				return False
		else:
			if setup_dict.has_key(steam):
				if setup_dict[steam]['Play with AWP and Auto-Sniper'] != 0:
					if args[1].lower() in restrictedList:
						es.playsound(userid, "buttons/weapon_cant_buy.wav", 1.0)
						es.tell(userid, '#multi', text('res',{},playerlib.getPlayer(userid).get('lang')))
						return False
	return True

			
def item_pickup(ev):
	item = ev['item']
	steam = ev['es_steamid']
	userid = int(ev['userid'])
	if steam not in featuresList:
		if item in restrictedList:
			index = playerlib.getPlayer(userid).getWeaponIndex(item)
			if index:
				es.playsound(userid, "buttons/weapon_cant_buy.wav", 1.0)
				es.tell(userid, '#multi', text('res',{},playerlib.getPlayer(userid).get('lang')))
				es.server.queuecmd('es_xremove %s'% index)
	else:
		if setup_dict.has_key(steam):
			if setup_dict[steam]['Play with AWP and Auto-Sniper'] != 0:
				if item in restrictedList:
					index = playerlib.getPlayer(userid).getWeaponIndex(item)
					if index:
						es.playsound(userid, "buttons/weapon_cant_buy.wav", 1.0)
						es.tell(userid, '#multi', text('res',{},playerlib.getPlayer(userid).get('lang')))
						es.server.queuecmd('es_xremove %s'% index)
	if pm_zombie_allow == 1:
		if steam in zombielist2:
			if item != 'knife':
				gamethread.delayed(0.3, es.server.queuecmd, 'es_xgive %s player_weaponstrip' % userid)
				gamethread.delayed(0.3, es.server.queuecmd, 'es_xfire %s player_weaponstrip strip' % userid)
				es.delayed(0.4,'es_xgive %s %s' % (userid, "weapon_knife"))
	if pm_chicken_allow == 1:
		if steam in chickenlist2:
			if item != 'knife':
				gamethread.delayed(0.3, es.server.queuecmd, 'es_xgive %s player_weaponstrip' % userid)
				gamethread.delayed(0.3, es.server.queuecmd, 'es_xfire %s player_weaponstrip strip' % userid)
				es.delayed(0.4, 'es_xgive %s %s' % (userid, "weapon_knife"))

def change_skin_pm(userid, steam):
	if setup_dict.has_key(steam):
		if setup_dict[steam]['Set Skin'] != 0:
			playerlib.getPlayer(userid).setModel(setup_dict[steam]['Set Skin'])
	
						
def prchatfilter(userid, text, teamonly):
	if teamonly:
		for player in es.getUseridList():
			steam = es.getplayersteamid(player)
			if steam in featuresList:
				if es.getplayerteam(player) != es.getplayerteam(userid):
					if setup_dict.has_key(steam):
						if setup_dict[steam]['Read Private Chat of Enemy Team'] == 0:
							es.tell(player, "#multi", "#default#green[%s wrote in ENEMYCHAT]#default: %s" % (es.getplayername(userid), text))
	return (userid, text, teamonly)
			

	
def disableAutokick(userid):
	es.server.mp_disable_autokick(userid)
	
def player_footstep(ev):
	steam = ev['es_steamid']
	if pm_enemydisplay_allow == 1:
		if steam in featuresList:
			if setup_dict.has_key(steam):
				if setup_dict[steam]['Show the nearest Enemy'] == 0:
					if steam != 'BOT':
						v = GetNearList(ev['userid'])
						if v:
							nearest_player = sorted(v, lambda x,y: SortDict(x,y,v))[0]
							distance = v[nearest_player]
							usermsg.hudhint(ev['userid'], "Enemy: %s\n %s Meter" %(es.getplayername(nearest_player),int(round(distance))))

def GetNearList(userid):
	team = es.getplayerteam(userid)
	xx,yy,zz = es.getplayerlocation(userid)
	NearList = {}
	for player in es.getUseridList():
		if not int(es.getplayerprop(player, 'CBasePlayer.pl.deadflag')):
			if es.getplayerteam(player) != team and es.getplayerteam(player) > 1:        
				x,y,z = es.getplayerlocation(player)
				NearList[player] = (((xx - x) ** 2 + (yy - y) ** 2 + (zz - z) ** 2) ** 0.5) / 40.0
	return NearList
        
def SortDict(item1, item2, items):
	item1 = abs(item1)
	item2 = abs(item2)
	if items[item1] < items[item2]: return -1
	if items[item1] == items[item2]: return 0
	return 1
	
#########################################################################################		
# Downloads:                                                                            #
#########################################################################################
	
	
def download():
	if os.path.isfile(apath + '/downloads.cfg'):
		for a in r_download():
			es.stringtable('downloadables', a)
			
def r_download():
	if os.path.isfile(apath + '/downloads.cfg'):
		a = open(apath + '/downloads.cfg', 'r')
		b = a.readlines()
		a.close()
		return map(lambda x: x.replace('\n', '').replace('\\', '/').replace('downloadable', ''), filter(lambda x: not x.startswith('//') and not x == '\n' and len(x) >= 10, b))

#########################################################################################		
# Say:                                                                                  #
#########################################################################################
		
def saytext2(userid,index,msg,arg1="",arg2="",arg3="",arg4=""):
	if es.exists('userid',userid):
		es.usermsg('create','saytext2','SayText2')
		es.usermsg('write','byte','saytext2',index)
		es.usermsg('write','byte','saytext2',True)
		es.usermsg('write','string','saytext2',msg)
		es.usermsg('send','saytext2',userid)
		es.usermsg('delete','saytext2')

def say(userid, text, teamOnly):
	text2 = str(text).strip('"')
	if int(userid) == -1:
		for ply in playerlib.getPlayerList('#all'):
			usermsg.echo(int(ply), 'Console: %s' % text2)
			saytext2(int(ply), 0, '\1Console\1: %s' % text2)
			return
	player = playerlib.getPlayer(userid)
	if player.attributes['teamid'] == 1:
		saySpec(userid, text2, teamOnly)
	if player.attributes['teamid'] == 2:
		sayT(userid, text2, teamOnly)
		
	if player.attributes['teamid'] == 3:
		sayCT(userid, text2, teamOnly)
	del player
	
def PremiumTalk(userid, text, teamOnly):
	player = playerlib.getPlayer(userid)
	sID = player.attributes['steamid']
	SayHooks = ["vote","rpgmenu","wcs","changerace","raceinfo","shopinfo","prop","props","propmenu","spendskills","race","motd","!wcs","shopmenu","playerinfo", "wcsmenu", "rank", "statsme", "session", "thetime", "google", "rtv", "rockthevote", "nominate", "nextmap", "timeleft", "listmaps", "votemap", "hitboxme", "top", "top10", "votekick", "voteban", "chicken", "zombie","rankme", "nextmap", "timeleft", "listmaps", "votemap", "hitboxme", "top", "top10", "votekick", "voteban", "chicken", "zombie"]
	SayFinds = ["@","/","!"]
	text2 = str(text).strip('"')
	for v in SayFinds:
		if text2.startswith(v):
			return userid, text, teamOnly
	if text2.lower() in SayHooks:
		return userid, text.lower(), teamOnly
	if sID in featuresList:
		say(userid, text, teamOnly)
		return 0, '', teamOnly
	else:
		return userid, text, teamOnly
		
def sayT(userid, text, teamOnly):
	player = playerlib.getPlayer(userid)
	isDeath = player.attributes['isdead']
	Name = player.attributes['name']
	index = player.attributes['index']
	sID = player.attributes['steamid']
	if teamOnly:
		if isDeath:
			for ply in playerlib.getPlayerList('#t,#dead'):
				usermsg.echo(int(ply), '*DEAD*(Terrorist) %s :  %s'% (Name, text))
				saytext2(int(ply), index, '\1*DEAD*(Terrorist) \3%s\1 :  %s' % (Name, text))
		else:
			for ply in playerlib.getPlayerList('#t'):
				usermsg.echo(int(ply), '(Terrorist) %s :  %s'% (Name, text))
				saytext2(int(ply), index, '\1(Terrorist) \3%s\1 :  %s' % (Name, text))
	else:
		if isDeath:
			for ply in playerlib.getPlayerList('#dead'):
				usermsg.echo(int(ply), '*DEAD* %s :  %s'% (Name, text))
				if sID in featuresList:
					if setup_dict.has_key(sID):
						if setup_dict[sID]['VIP Tag Chat'] == 0:
							saytext2(int(ply), index, '\4%s \1*DEAD* \3%s\1 :  %s' % (pm_tag_text, Name, text))
		else:
			for ply in playerlib.getPlayerList('#all'):
				usermsg.echo(int(ply), '%s :  %s' % (Name, text))
				if sID in featuresList:
					if setup_dict.has_key(sID):
						if setup_dict[sID]['VIP Tag Chat'] == 0:
							saytext2(int(ply), index, '\1\4%s \3%s\1 :  %s'% (pm_tag_text, Name, text))


def sayCT(userid, text, teamOnly):
	player = playerlib.getPlayer(userid)
	isDeath = player.attributes['isdead']
	Name = player.attributes['name']
	index = player.attributes['index']
	sID = player.attributes['steamid']
	if teamOnly:
		if isDeath:
			for ply in playerlib.getPlayerList('#ct,#dead'):
				usermsg.echo(int(ply), '*DEAD*(Counter-Terrorist) %s :  %s'% (Name, text))
				saytext2(int(ply), index, '\1*DEAD*(Counter-Terrorist) \3%s\1 :  %s'% (Name, text))
		else:
			for ply in playerlib.getPlayerList('#ct'):
				usermsg.echo(int(ply), '(Counter-Terrorist) %s :  %s'% (Name, text))
				saytext2(int(ply), index, '\1(Counter-Terrorist) \3%s\1 :  %s'% (Name, text))
	else:
		if isDeath:
			for ply in playerlib.getPlayerList('#dead'):
				usermsg.echo(int(ply), '*DEAD* %s :  %s'% (Name, text))
				if sID in featuresList:
					if setup_dict.has_key(sID):
						if setup_dict[sID]['VIP Tag Chat'] == 0:
							saytext2(int(ply), index, '\4%s \1*DEAD* \3%s\1 :  %s'% (pm_tag_text, Name, text))
		else:
			for ply in playerlib.getPlayerList('#all'):
				usermsg.echo(int(ply), '%s :  %s'% (Name, text))
				if sID in featuresList:
					if setup_dict.has_key(sID):
						if setup_dict[sID]['VIP Tag Chat'] == 0:
							saytext2(int(ply), index, '\1\4%s \3%s\1 :  %s'% (pm_tag_text, Name, text))


def saySpec(userid, text, teamOnly):
	player = playerlib.getPlayer(userid)
	isDeath = player.attributes['isdead']
	Name = player.attributes['name']
	index = player.attributes['index']
	if teamOnly:
		for ply in playerlib.getPlayerList('#spec,#dead'):
			usermsg.echo(int(ply), '(Spectator) %s :  %s'% (Name, text))
			saytext2(int(ply), index, '\1(Spectator) \3%s\1 :  %s'% (Name, text))
	else:
		for ply in playerlib.getPlayerList('#dead'):
			usermsg.echo(int(ply), '*SPEC* %s :  %s'% (Name, text))
			saytext2(int(ply), index, '\1*SPEC* \3%s\1 :  %s'% (Name, text))

#########################################################################################		
# Popups:                                                                               #
#########################################################################################

def modelfeatures(userid):
	global skinMenu
	skinMenu = popuplib.easymenu('skinMenu', None, selectskin)
	team = es.getplayerteam(userid)
	if team == 2:
		skinMenu.settitle("-> PremiumMod Made by RoOF\nSkinChooser:\nFor Terrorist Team")
		for x in models_t:
			skinMenu.addoption(models_t[x]['path'], x)
	if team == 3:
		skinMenu.settitle("-> PremiumMod Made by RoOF\nSkinChooser:\nFor CounterTerrorist Team")
		for x in models_ct:
			skinMenu.addoption(models_ct[x]['path'], x)
	skinMenu.send(userid)

def infomenu(userid):
	global menu2
	steam = es.getplayersteamid(userid)
	menu2 = popuplib.create('menu2')
	menu2.addline('-> PremiumMod Made by RoOF')
	menu2.addline(' ')
	if steam in playerinfo:
		menu2.addline('Your Premium Account runs out at: %s' % playerinfo[steam]['expire'])
	menu2.addline(' ')
	if steam in playerinfo:
		menu2.addline('Your Infos:\nName: %s\nEmail: %s\nSteamID: %s' % (playerinfo[steam]['name'], playerinfo[steam]['email'], steam))
	menu2.addline(' ')
	menu2.addline('->1. Change Your Personal Premium Settings')
	menu2.addline('->2. See all PremiumMod ChatCommands')
	menu2.addline('->3. See Addon Infos')
	menu2.menuselect = player_vote6
	menu2.send(userid)


	
def info2(userid):
	global menu3
	menu3 = popuplib.create('menu3')
	menu3.addline('-> PremiumMod Made by RoOF')
	menu3.addline(' ')
	menu3.addline('->1. Open Guns Menu: %s' % pm_weapons_force)
	menu3.addline('->2. Open Skin Menu: %s' % pm_skin_force)
	menu3.addline('->3: Play as Chicken %s' % pm_chicken_force)
	menu3.addline('->3: Play as Zombie %s' % pm_zombie_force)
	menu3.addline(' ')
	menu3.menuselect = player_vote7
	menu3.send(userid)
	
def info3(userid):
	global menu4
	menu4 = popuplib.create('menu')
	menu4.addline('-> PremiumMod Made by RoOF')
	menu4.addline(' ')
	menu4.addline('Addonname: PremiumMod\nVersion: %s\nAuthor: RoOF\nDownload it: %s' % (info["version"],info["url"]))
	menu4.addline(' ')
	menu4.send(userid)
	
def selectskin(userid, choice, popupid):
	es.playsound(userid, "buttons/button14.wav", 1.0)
	team = es.getplayerteam(userid)
	steam = es.getplayersteamid(userid)
	player = playerlib.getPlayer(userid)
	setup_dict[steam]['Set Skin'] = choice
	if choice != 0:
		player.setModel(choice)
		if team == 2:
			for x in models_t:
				es.tell(userid, '#multi', text('skin1',{'v1': x},player.get('lang')))
		if team == 3:
			for x in models_ct:
				es.tell(userid, '#multi', text('skin1',{'v1': x},player.get('lang')))
		change_skin_pm(userid, steam)

def weapongiver(userid):
	global wpopup
	wpopup = popuplib.easymenu("Waffen_popup", None, weapongiver_select)
	wpopup.settitle("-> PremiumMod by RoOF\nWeapon Giver:")
	for w in sorted(weaponlib.getWeaponNameList()):
		wpopup.addoption(w, w.upper().replace('WEAPON_', ''))
	wpopup.send(userid)
	
def weapongiver_select(userid, choice, popupid):
	es.playsound(userid, "buttons/button14.wav", 1.0)
	weapongiver(userid)
	if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
		es.server.queuecmd('es_xgive %s %s' % (userid, choice))
		es.tell(userid, '#multi', text('waf',{'v1': choice},playerlib.getPlayer(userid).get('lang')))
	else:
		es.tell(userid, '#multi', text('alive',{},playerlib.getPlayer(userid).get('lang')))
	
def respawn(userid):
	global menu
	menu = popuplib.create('menu')
	menu.addline('-> PremiumMod Made by RoOF')
	menu.addline(' ')
	menu.addline('Do You want to Respawn?')
	menu.addline(' ')
	menu.addline('->1. Yes')
	menu.addline('->2. No ')
	menu.addline(' ')
	menu.menuselect = player_vote5
	menu.send(userid)
	
	

def createMenu(userid):
	steam = es.getplayersteamid(userid)
	if popuplib.exists('easy'):
		popuplib.delete('easy')
	v = popuplib.easymenu('easy', '_popup_choice', menu1)
	v.settitle('-> PremiumMod Made by RoOF:')
	for x in setup_dict[steam]:
		if setup_dict[steam][x] == 1:
			v.addoption(x, x +': Off')
		else:	
			v.addoption(x, x +': On')
	v.send(userid)

def menu1(userid, choice, popupid):
	es.playsound(userid, "buttons/button14.wav", 1.0)
	steam = es.getplayersteamid(userid)
	if choice in setup_dict[steam]:
		if setup_dict[steam][choice] != 1:
			setup_dict[steam][choice] = 1
		else:
			setup_dict[steam][choice] = 0
		createMenu(userid)
		
def player_vote5(userid, choice, name):
	if choice == 0:
		respawn(userid)
	elif choice == 1:
		gamethread.delayed(.1, es.server.queuecmd, 'es_xsetplayerprop %s CBasePlayer.m_lifeState 512' % userid)
		gamethread.delayed(.1, es.server.queuecmd, 'es_xsetplayerprop %s CCSPlayer.m_iPlayerState 0' % userid)
		gamethread.delayed(.1, es.server.queuecmd, 'es_xspawnplayer %s' % userid)
		es.tell(userid, '#multi', text('resp',{},playerlib.getPlayer(userid).get('lang')))
	elif choice == 2:
		es.tell(userid, '[PremiumMod] Ok Maybe you want to respawn the next time')
	elif choice >= 2:
		respawn(userid)
	
def player_vote7(userid, choice, name):
	steam = es.getplayersteamid(userid)
	player = playerlib.getPlayer(userid)
	if choice == 1:
		weapongiver(userid)
	elif choice == 2:
		modelfeatures(userid)
	elif choice == 3:
		if setup_dict[steam]['Play as Chicken'] == 0:
			if steam not in chickenlist:
				if steam not in zombielist:
					chickenlist.append(steam)
					for useridx in es.getUseridList():
						es.tell(useridx, '#multi', text('chickenforce',{'v1': es.getplayername(userid)},playerlib.getPlayer(useridx).get('lang')))
				else:
					es.tell(userid, text('playalreadyzm',{},player.get('lang')))			
			else:
				es.tell(userid, text('playalreadych',{},player.get('lang')))
	elif choice == 4:
		if setup_dict.has_key(steam):
			if setup_dict[steam]['Play as Zombie'] == 0:
				if steam not in zombielist:
					if steam not in chickenlist:
						zombielist.append(steam)
						for useridx in es.getUseridList():
							es.tell(useridx, '#multi', text('zombieforce',{'v1': es.getplayername(userid)},playerlib.getPlayer(useridx).get('lang')))
					else:
						es.tell(userid, text('playalreadych',{},player.get('lang')))
				else:
					es.tell(userid, text('playalreadyzm',{},player.get('lang')))

	
def player_vote6(userid, choice, name):
	if choice == 1:
		createMenu(userid)
	elif choice == 2:
		info2(userid)
	elif choice == 3:
		info3(userid)
		
		
#########################################################################################		
# Grenade Trail:                                                                        #
#########################################################################################

class TickManager(object):
	global precache1
	refcount = 0
	def __init__(self):
		self.projectiles = dict()
		self.reset()
	def start(self):
		if not self.refcount:
			es.addons.registerTickListener(self.tick)
		self.refcount += 1
	def stop(self):
		projectiles = self.projectiles
		for index1 in set(projectiles).difference(es.getEntityIndexes('hegrenade_projectile')):
			del projectiles[index1]
		for index2 in set(projectiles).difference(es.getEntityIndexes('flashbang_projectile')):
			del projectiles[index2]
		for index3 in set(projectiles).difference(es.getEntityIndexes('smokegrenade_projectile')):
			del projectiles[index3]
		if self.refcount:
			self.refcount -= 1
		if not self.refcount:
			es.addons.unregisterTickListener(self.tick)
	def reset(self):
		self.projectiles.clear()
		if self.refcount:
			self.refcount = 0
			es.addons.unregisterTickListener(self.tick)

	def tick(self):
		projectiles = self.projectiles
		for userid in es.getUseridList():
			steam = es.getplayersteamid(userid)
			if steam in featuresList:
				if steam in setup_dict:
					if setup_dict[steam]['Grenade Trails'] == 0:
						for index1 in es.getEntityIndexes("hegrenade_projectile"):
							location = es.getindexprop(index1, 'CBaseEntity.m_vecOrigin')
							if es.getindexprop(index1, "CBaseEntity.m_hOwnerEntity") == es.getplayerhandle(userid):
								if index1 in projectiles:
									es.effect('beam', location, projectiles[index1], precache1, precache1,
									0, 0.5, 0.4, 2, 2, 0, 0, 0, 0, 255, 160, 100)
								projectiles[index1] = location
						for index2 in es.getEntityIndexes('flashbang_projectile'):
							location = es.getindexprop(index2, 'CBaseEntity.m_vecOrigin')
							if es.getindexprop(index2, "CBaseEntity.m_hOwnerEntity") == es.getplayerhandle(userid):
								if index2 in projectiles:
									es.effect('beam', location, projectiles[index2], precache1, precache1,
									0, 0.5, 0.4, 2, 2, 0, 0, 255, 255, 0, 160, 100)
								projectiles[index2] = location
						for index3 in es.getEntityIndexes('smokegrenade_projectile'):
							location = es.getindexprop(index3, 'CBaseEntity.m_vecOrigin')
							if es.getindexprop(index3, "CBaseEntity.m_hOwnerEntity") == es.getplayerhandle(userid):
								if index3 in projectiles:
									es.effect('beam', location, projectiles[index3], precache1, precache1,
									0, 0.5, 0.4, 2, 2, 0, 0, 0, 255, 0, 160, 100)
								projectiles[index3] = location
         
ticker = TickManager()


	